/*
Copyright  2005 by Jaime R. Wilkesheski aka Durvivor

Permission to use, copy, modify and distribute this software and its documentation for any purpose and without fee is hereby granted, provided that the above copyright notice appear in all copies and that both the copyright notice and this permission notice appear in supporting documentation.  Jaime R. Wilkesheski aka Durvivor makes no representations about the suitability of this software for any purpose. It is provided "as is" without express or implied warranty.

JAIME R. WILKESHESKI AKA DURVIVOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL JAIME R. WILKESHESKI AKA DURVIVOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/

// Global Variables
var GAMEDURATION=31;

var fDelay=1;
var fIncre=4;

var cash=0;
var bank=0;
var shark=0;

var drugPrices = new Array(8);  
var drugQtys = new Array(8);   

var currentBorough="NewJersey";
var gun=0;
var day=1;
var pockets=100;

var cops=3;
var dead=0;

var bankInterest=1.1
var sharkInterest=1.125

var nextFi="";
var currFi="";
var maxLoan=0;
var lentOut=0;
   
var events = new Array(17);
var currentEvent=0;
var eventFrequencyFactor=1000000;

var strOtherEvent="";

var fuzzEvent="";


/*
    * Manhattan
    * Brooklyn
    * Queens
    * The Bronx
    * Staten Island
*/






function jetToBorough( boroughText )
{
   if ( boroughText != currentBorough )
   {
      document.getElementById("problemText").innerHTML="";
      currentBorough=boroughText;
      // Start chain of events.
      fuzz();
   }
   else
   {
      document.getElementById("problemText").innerHTML="You are already in "+boroughText;
   }
}



function fuzz()
{
   // Roll the dice 1 n 7 chance
   if ( oddsCalculator( 7 )  || fuzzEvent != "" )
   {
      if ( cops > 0 )
      {
      fuzzEvent="";
   
      // If we ha ha, "get lucky" 
      // Display the fuzz div.
      var msg="";
      if ( cops == 3 )
         msg="Officer Hardass and two of his deputies are chasing you";
      else if ( cops == 2)
         msg="Officer Hardass and his deputy are chasing you";
      else if ( cops == 1 )
         msg="Officer Hardass is chasing you";

      document.getElementById('fuzzText').innerHTML=msg;
      
      document.getElementById('run').style.display='block';
      document.getElementById('fight').style.display='block';
      document.getElementById('fok').style.display='none';
      document.getElementById('fuzz').style.display = 'block';
      }

   }
   else  
   {
      // Move on to pockets.
      fpockets();
   }
}

function fuzzFight( )
{
   // Gotta Gun?
   if ( gun == 1 )
   {
      // Ok, your gonna fight
      // Any cops left?
      if ( cops > 0 )
      {
         // Yep, there are cops.
         // You have a 1 in 4 shot at hitting them.
         if ( oddsCalculator( 4 ) ) 
         {
	    cops--;

            if ( cops < 1 )
            {
               fuzzEvent="";
               var msg = "You shot and killed one of the cops.  Now there are no more cops, deal on."
            }
            else
            {
               fuzzEvent="wannafight";
               var msg = "You shot and killed one of the cops."
            }
            document.getElementById('fuzzText').innerHTML=msg;      
            document.getElementById('run').style.display='none';
            document.getElementById('fight').style.display='none';
            document.getElementById('fok').style.display='block';
         }
         else
         {
	    fuzzEvent="keepfight";
            var msg = "You shot at the cops, but missed.";
            document.getElementById('fuzzText').innerHTML=msg;      
            document.getElementById('run').style.display='none';
            document.getElementById('fight').style.display='none';
            document.getElementById('fok').style.display='block';
         }
      }
      else
      {
            var msg = "No more cops, deal on.";
            fuzzEvent="";
            document.getElementById('fuzzText').innerHTML=msg;      
            document.getElementById('run').style.display='none';
            document.getElementById('fight').style.display='none';
            document.getElementById('fok').style.display='block';
      }
   }
   else
   {
      // No Gun
      fuzzEvent="wannafight";
      var msg = "You do not have a gun."
      document.getElementById('fuzzText').innerHTML=msg;      
      document.getElementById('run').style.display='none';
      document.getElementById('fight').style.display='none';
      document.getElementById('fok').style.display='block';
   }
}


function fuzzFightBack()
{

     fuzzEvent="";

      document.getElementById('fuzz').style.display = 'block';
	
     // Now the cops get to shoot at you.
     // Serves you right!  You should not be 
     // dealing drugs or fighting cops.
     // 1 in 5 chance of getting hit.
     if ( oddsCalculator( 5 ) ) 
     {
         // 1 in 5 chance of dying
         if ( oddsCalculator( 5 ) ) 
         {
              fuzzEvent="gameover";
              dead=1;
              var msg = "The cops shot you.  You died."
              document.getElementById('fuzzText').innerHTML=msg;      
              document.getElementById('run').style.display='none'
              document.getElementById('fight').style.display='none';
              document.getElementById('fok').style.display='block';
              // GAME OVER
         }
         else
         {
              fuzzEvent="wannafight";
              var msg = "The cops shot you, and you are wounded."
              document.getElementById('fuzzText').innerHTML=msg;      
              document.getElementById('run').style.display='none'
              document.getElementById('fight').style.display='none';
              document.getElementById('fok').style.display='block';
         }
     }
     else
     {
         fuzzEvent="wannafight";
         var msg = "The cops shot at you, but missed."
         document.getElementById('fuzzText').innerHTML=msg;      
         document.getElementById('run').style.display='none'
         document.getElementById('fight').style.display='none';
         document.getElementById('fok').style.display='block';
     }
     
}

//The cops shot you, and you are wounded.
//The cops shot you, and you are wounded.
//The cops seized all your dope and half your cash.
//The cops shot at you, but missed.
//Officer Hardass ^1^2still chasing you!  What do you do?^3
//The cops shot you.  You died.
//You shot at the cops, but missed.
//You lost them in the alleys.


/*

When you run into the cops, 
STRING kidCopHelp "When you run into the cops, you have two options: Run or Fight.\n\n" \
 "You can only fight if you have a gun.  During the game, you may have the " \
"opportunity to buy a gun.\n\n" \
"If you run, it is unlikely that the cops will catch you; but if they do, " \
 "they will seize all your drugs and half of your cash.\n\n" \
 "If you fight, you have the chance of killing off the cops, and not be " \
"bothered for the rest of the game.  However, if you fight the cops, it is " \
"fairly likely that you will be wounded and caught, and you might even be " \
"killed.  It's the risk you have to take if you decide to protect your " \
"livelihood.\n\n" \
"The cops will not chase you if your coat is empty."

*/




function fuzzRun()
{
   // This is your first chance to get away.
   if ( oddsCalculator( 3 ) )
   {
        // 2nd chance (and its better)
        if ( oddsCalculator( 5 ) )
        {

               // Caught
               // Lose All your Dope
               // And 1/2 your cash.
               var msg = "You ran into a dead end, and the cops found you.";
                   msg+= "The cops seized all your dope and half your cash.";
               document.getElementById('fuzzText').innerHTML=msg;

               cash=cash/2;
	       cash=Math.round(cash);

	       for ( var i = 0 ; i < 8 ; i++ )
               {
                    drugQtys[i]=0;
               }

               document.getElementById('run').style.display='none';
               document.getElementById('fight').style.display='none';
               document.getElementById('fok').style.display='block';

       
            
        }
        else
        {
             // Your away
             fuzzAway( );
        }
   }
   else
   {
      // Your away
      fuzzAway( );
   }
}

function fuzzAway()
{
     // Turn on OK.
     document.getElementById('run').style.display='none';
     document.getElementById('fight').style.display='none';
     document.getElementById('fok').style.display='block';

     var msg = "You lost them in the alleys.";
     document.getElementById('fuzzText').innerHTML=msg;
     
}

function fuzzResponse( yesno )
{

   document.getElementById('fuzz').style.display = 'none';
   if ( fuzzEvent == "gameover" )
   {
      // END GAME?
      displayGameOver();
   } 
   else if ( fuzzEvent == "wannafight" )
   {
      // Back to the fight.
      fuzz();
   }
   else if ( fuzzEvent == "keepfight" )
   {
      fuzzFightBack();
   }
   else
   {
      fpockets();   
   }
}


function fpockets()
{
   // Roll the dice 1 n 7 chance
   if ( oddsCalculator( 10 ) && cash > 200 )
   {
      // If we ha ha, "get lucky" 
      // Display the pockets div.
      document.getElementById('pockets').style.display = 'block';
   }
   else
   {
      // Move on to gun.
      fgun();
      
   }
}

function pocketsResponse( yesno )
{
   document.getElementById('pockets').style.display = 'none';
   if ( yesno )
   {
      pockets+=40;
      cash-=200;
      fgun();
   }
   else
   {
      fgun();
   }

}


function fgun()
{
   // Roll the dice 1 n 7 chance
   // and make sure we don't have one already.

   if ( oddsCalculator( 10 ) && gun == 0 && cash > 400 )
   {
      // If we ha ha, "get lucky" 
      // Display the pockets div.
      document.getElementById('gun').style.display = 'block';
   }
   else
   {
      // Move on to messages.
      currentEvent=0;
      messageEvents(currentBorough);  
   }
}

function gunResponse( yesno )
{
   document.getElementById('gun').style.display = 'none';
   if ( yesno )
   {
      gun+=1;
      cash-=400;
      // Move on to messages.
      currentEvent=0;
      messageEvents(currentBorough);
   }
   else
   {
      // Move on to messages.
      currentEvent=0;
      messageEvents(currentBorough);
   }
}



function oddsCalculator( odds )
{
   // Pick a random number 0 .. 1,000,000 ?
   var iRandom = Math.floor(Math.random()*eventFrequencyFactor);
   var iResult = iRandom % odds ;
   if ( iResult == 0 )
      return true;
   else
      return false;
}



function messageEvents( boroughText )
{
   if ( currentEvent < events.length )
   {
      // Pick a random number 0 .. 1,000,000 ?
      var iRandom = Math.floor(Math.random()*eventFrequencyFactor);

      // Each event has a odds factor.  [0]  
      // Mod the random number by the odds.
      // If the result is 0 then do the event.
      var iResult = iRandom % events[currentEvent][0] ;

      if ( iResult == 0 )   // DO IT
      {
         // Display Message 
         document.getElementById('messageText').innerHTML=events[currentEvent][1];
         // Multiply Price
         if ( events[currentEvent][3] > 0 ) 
         {
            drugPrices[ events[currentEvent][2] ] = drugPrices[ events[currentEvent][2] ] * events[currentEvent][3] ;
         }
         // Divideiply Price
         if ( events[currentEvent][4] > 0 ) 
         {
            drugPrices[ events[currentEvent][2] ] = drugPrices[ events[currentEvent][2] ] / events[currentEvent][4] ;
         }
         // Add Drugs
         if ( events[currentEvent][5] > 0 ) 
         {
            var foundDrugs = Math.floor(Math.random()*events[currentEvent][5]);
            // You got say 100 pockets - 99 qty = 1... You get 1 drug.
            var drugRoom = pockets - countQty();

            if ( drugRoom == 0 ) // you got no room.
            {
               // Nothing happens.
            }
            else if ( foundDrugs < drugRoom )   
            {
               // Room for all the found drugs.
               drugQtys[ events[currentEvent][2] ] += foundDrugs ;
            }
            else 
            {
               // Apparantly you have room or 0 .. ? drugs
               drugQtys[ events[currentEvent][2] ] += drugRoom ;
            }
            
            
            // Don't this anymore.
            // It might give you more drugs than room.
            //drugQtys[ events[currentEvent][2] ] += 
            //Math.floor(Math.random()*events[currentEvent][5])
         }

         currentEvent++;
         displayMessageDiv();
      
      }
      else
      {
         currentEvent++;
         messageEvents( boroughText )
      }
   }
   else
   {

      roundPrices();

      // If Bronx then ask to visit the shark & bank
      if ( currentBorough == "Bronx" )
      {
         nextFi="shark";
         //setTimeout("askJetToFi(false)",100);
         askJetToFi(false);
      }
      else
      {
         processJetToBorough();
      }
   }
}

function askJetToFi( yesno )
{
   if ( nextFi == "shark" )
   {

      nextFi = "sharkR";
      document.getElementById("askMessageText").innerHTML="Do you want to visit the Loan Shark?";
      document.getElementById("financialInstitution").style.display='none';
      document.getElementById('message').style.display='none';
      document.getElementById('face').style.display='none';
      document.getElementById('ask').style.display='block';
   }
   else if ( nextFi == "sharkR" )
   {
      nextFi = "bank";
      currFi = "shark";
      if ( yesno )
      {
            updateFiAmounts();
            maxLoan=cash*30;
            lentOut=0;
            document.getElementById("financialInstitutionImg").src="shark.png";
            document.getElementById("fiName").innerHTML="Loan Shark";
            document.getElementById('ask').style.display='none';
            document.getElementById("financialInstitution").style.display='block';
      }
      else
      {
         askJetToFi( false );
      }
   }
   else if ( nextFi == "bank" )
   {
      nextFi = "bankR";
      document.getElementById("askMessageText").innerHTML="Do you want to visit the Bank?";
      document.getElementById("financialInstitution").style.display='none';
      document.getElementById('ask').style.display='block';
   }
   else if ( nextFi == "bankR" )
   {
      nextFi = "done";
      currFi = "bank";
      if ( yesno )
      {
            updateFiAmounts();
            document.getElementById("financialInstitutionImg").src="bank.png";
            document.getElementById("fiName").innerHTML="Bank";
            document.getElementById('ask').style.display='none';
            document.getElementById("financialInstitution").style.display='block';
      }
      else
      {
         askJetToFi( false );
      }
   }
   else if ( nextFi == "done" )
   {  
      document.getElementById('ask').style.display='none';
      document.getElementById("financialInstitution").style.display='none';
      processJetToBorough( currentBorough );
   } 
}





function updateFiAmounts()
{
   if ( currFi == "shark" )
   {
      document.getElementById("fiBalanceInd").innerHTML="You Owe";
      document.getElementById("fiBalance").innerHTML= CurrencyFormatted(shark);
      document.getElementById("fiCash").innerHTML= CurrencyFormatted(cash);
   }
   else if ( currFi == "bank" )
   {
      document.getElementById("fiBalanceInd").innerHTML="Your Balance";
      document.getElementById("fiBalance").innerHTML= CurrencyFormatted( bank);
      document.getElementById("fiCash").innerHTML= CurrencyFormatted( cash);
   }
  
}


function take(amount)
{
/*
var cash=2000;
var bank=0;
var shark=-5500;
*/

   if ( currFi == "shark" )
   {
      if ( lentOut+parseInt(amount) <= maxLoan )
      {
         shark+=parseInt(amount);
         cash+=parseInt(amount);
         lentOut+=parseInt(amount);
      }
 
   }
   else if ( currFi == "bank" )
   {
      if ( bank >= parseInt(amount) ) 
      {
         bank-=parseInt(amount);
         cash+=parseInt(amount);
      }
   }

   updateFiAmounts();

}

function give(amount)
{
   if ( currFi == "shark" )
   {
      // If you have more cash than the shark
      if ( cash >= parseInt(amount) && shark >= parseInt(amount) )
      {
         cash-=parseInt(amount);
         shark-=parseInt(amount);
         lentOut-=parseInt(amount);
      }         
   }
   else if ( currFi == "bank" )
   {
      if ( cash >= parseInt(amount) )
      {
         cash-=parseInt(amount);
         bank+=parseInt(amount);
      }
   }

   updateFiAmounts();
}

function giveAll()
{
   if ( currFi == "shark" )
   {
      if ( cash > shark )
      {
         lentOut-=shark;
         cash-=shark;
         shark-=shark;
      }
      else  // You owe more than you have.
      {
         shark-=cash;
         lentOut-=cash;
         cash-=cash;
      }
   }
   else if ( currFi == "bank" )
   {
      if ( cash > 0 )
      {
         bank+=cash;
         cash-=cash;
      }
   }

   updateFiAmounts();
}

function takeAll()
{
   if ( currFi == "shark" )
   {
      var iCalc = maxLoan - lentOut ;
      shark+=iCalc;
      cash+=iCalc;
      lentOut+=iCalc;    
   }
   else if ( currFi == "bank" )
   {
      if ( bank > 0 )
      {
         cash+=bank;
         bank-=bank;
      }
   }

   updateFiAmounts();
}




function processJetToBorough( boroughText )
{
   var jet     = document.getElementById("face"); 
   var message = document.getElementById("message");
   var borough = document.getElementById("borough");

   var gunText="";
   if ( gun == 0 ) { gunText = "No Gun" } else { gunText = "Gun" }
   document.getElementById('havegun').innerHTML=gunText;

   var dayText = "Day ";
   dayText += day ;
   document.getElementById('day').innerHTML=dayText;

   displayMoney();
   displayQtys();
   displayPrices();
   displayPockets();

   document.getElementById('boroughName').innerHTML= convertBorough();
  
   if ( day > GAMEDURATION )
   {
      displayGameOver();
   }
   else
   {
      displayBoroughDiv();
   }


}







/******************************************************
*******************************************************/

function initQtys()
{
   for ( var i = 0 ; i < 8 ; i++ )
   {
      drugQtys[i]=0;
   }
}

function initPrices()
{
   for ( var i = 0 ; i < 8 ; i++ )
   {
      drugPrices[i]=0;
   }
}

function changePrices()
{
     drugPrices[0] = 1000 + Math.floor(Math.random()*3500);
     drugPrices[1] = 15000 + Math.floor(Math.random()*15000);
     drugPrices[2] = 10 + Math.floor(Math.random()*50);
     drugPrices[3] = 1000 + Math.floor(Math.random()*2500);
     drugPrices[4] = 5000 + Math.floor(Math.random()*9000);
     drugPrices[5] = 300 + Math.floor(Math.random()*600);
     drugPrices[6] = 600 + Math.floor(Math.random()*750);
     drugPrices[7] = 70 + Math.floor(Math.random()*180);

     // Each drug has a 1 in 8 chance of not being available.
     for ( var i = 0 ; i < 8 ; i++ )
     {
        if ( oddsCalculator( 8 ) )
        {
           drugPrices[i]=0;
        }
     }

}




function initEvents()
{
   for ( var i = 0 ; i < events.length ; i++ )
   {
      events[i] = new Array(6);
   }

   events[0][0] = "13";      // Frequency
   events[0][1] = "The cops just did a big Weed bust!  Prices are sky-high!";   // Message
   events[0][2] = "5";   // ???
   events[0][3] = "4";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[0][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[0][5] = "0";   // Extra Drugs

   events[1][0] = "20";      // Frequency
   events[1][1] = "The cops just did a big PCP bust!  Prices are sky-high!";   // Message
   events[1][2] = "3";   // ???
   events[1][3] = "4";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[1][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[1][5] = "0";   // Extra Drugs

   events[2][0] = "25";      // Frequency
   events[2][1] = "The cops just did a big Heroin bust!  Prices are sky-high!";   // Message
   events[2][2] = "4";   // ???
   events[2][3] = "4";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[2][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[2][5] = "0";   // Extra Drugs

   events[3][0] = "13";      // Frequency
   events[3][1] = "The cops just did a big Ecstasy bust!  Prices are sky-high!";   // Message
   events[3][2] = "2";   // ???
   events[3][3] = "4";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[3][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[3][5] = "0";   // Extra Drugs

   events[4][0] = "35";      // Frequency
   events[4][1] = "The cops just did a big Cocaine bust!  Prices are sky-high!";   // Message
   events[4][2] = "1";   // ???
   events[4][3] = "4";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[4][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[4][5] = "0";   // Extra Drugs

   events[5][0] = "15";      // Frequency
   events[5][1] = "The cops just did a big Speed bust!  Prices are sky-high!";   // Message
   events[5][2] = "7";   // ???
   events[5][3] = "4";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[5][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[5][5] = "0";   // Extra Drugs

   events[6][0] = "25";      // Frequency
   events[6][1] = "Addicts are buying Heroin at outrageous prices!";   // Message
   events[6][2] = "4";   // ???
   events[6][3] = "8";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[6][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[6][5] = "0";   // Extra Drugs

   events[7][0] = "20";      // Frequency
   events[7][1] = "Addicts are buying Speed at outrageous prices!";   // Message
   events[7][2] = "7";   // ???
   events[7][3] = "8";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[7][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[7][5] = "0";   // Extra Drugs

   events[8][0] = "20";      // Frequency
   events[8][1] = "Addicts are buying PCP at outrageous prices!";   // Message
   events[8][2] = "3";   // ???
   events[8][3] = "8";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[8][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[8][5] = "0";   // Extra Drugs

   events[9][0] = "17";      // Frequency
   events[9][1] = "Addicts are buying Shrooms at outrageous prices!";   // Message
   events[9][2] = "6";   // ???
   events[9][3] = "8";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[9][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[9][5] = "0";   // Extra Drugs

   events[10][0] = "35";      // Frequency
   events[10][1] = "Addicts are buying Cocaine at outrageous prices!";   // Message
   events[10][2] = "1";   // ???
   events[10][3] = "8";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[10][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[10][5] = "0";   // Extra Drugs

   events[11][0] = "17";      // Frequency
   events[11][1] = "The market has been flooded with cheap home-made Acid!";   // Message
   events[11][2] = "0";   // ???
   events[11][3] = "0";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[11][4] = "8";   // Event Dividiplier (e.g. Weed price / 4 )
   events[11][5] = "0";   // Extra Drugs

   events[12][0] = "10";      // Frequency
   events[12][1] = "A Columbian freighter dusted the Coast Guard!  Weed prices have bottomed out!";   // Message
   events[12][2] = "5";   // ???
   events[12][3] = "0";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[12][4] = "4";   // Event Dividiplier (e.g. Weed price / 4 )
   events[12][5] = "0";   // Extra Drugs

   events[13][0] = "11";      // Frequency
   events[13][1] = "A gang raided a local pharmacy and are selling cheap Ecstasy!";   // Message
   events[13][2] = "2";   // ???
   events[13][3] = "0";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[13][4] = "8";   // Event Dividiplier (e.g. Weed price / 4 )
   events[13][5] = "0";   // Extra Drugs

   events[14][0] = "55";      // Frequency
   events[14][1] = "You found some Cocaine on a dead dude in the subway!";   // Message
   events[14][2] = "1";   // ???
   events[14][3] = "0";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[14][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[14][5] = "3";   // Extra Drugs

   events[15][0] = "45";        // Frequency
   events[15][1] = "You found some Acid on a dead dude in the subway!";   // Message
   events[15][2] = "0";   // ???
   events[15][3] = "0";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[15][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[15][5] = "6";   // Extra Drugs

   events[16][0] = "35";      // Frequency
   events[16][1] = "You found some PCP on a dead dude in the subway!";   // Message
   events[16][2] = "3";   // ???
   events[16][3] = "0";   // Event Multiplier (e.g. Event multiplies weed price x 4)
   events[16][4] = "0";   // Event Dividiplier (e.g. Weed price / 4 )
   events[16][5] = "4";   // Extra Drugs


/*
	{13, "The cops just did a big Weed bust!  Prices are sky-high!", 5, 4, 0, 0},
	{20, "The cops just did a big PCP bust!  Prices are sky-high!", 3, 4, 0, 0},
	{25, "The cops just did a big Heroin bust!  Prices are sky-high!", 4, 4, 0, 0},
	{13, "The cops just did a big Ludes bust!  Prices are sky-high!", 2, 4, 0, 0},
	{35, "The cops just did a big Cocaine bust!  Prices are sky-high!", 1, 4, 0, 0},
	{15, "The cops just did a big Speed bust!  Prices are sky-high!", 7, 4, 0, 0},
	{25, "Addicts are buying Heroin at outrageous prices!", 4, 8, 0, 0},
	{20, "Addicts are buying Speed at outrageous prices!", 7, 8, 0, 0},
	{20, "Addicts are buying PCP at outrageous prices!", 3, 8, 0, 0},
	{17, "Addicts are buying Shrooms at outrageous prices!", 6, 8, 0, 0},
	{35, "Addicts are buying Cocaine at outrageous prices!", 1, 8, 0, 0},
	{17, "The market has been flooded with cheap home-made Acid!", 0, 0, 8, 0},
	{10, "A Columbian freighter dusted the Coast Guard!  Weed prices have bottomed out!", 5, 0, 4, 0},
	{11, "A gang raided a local pharmacy and are selling cheap Ludes!", 2, 0, 8, 0},
	{55, "You found some Cocaine on a dead dude in the subway!", 1, 0, 0, 3},
	{45, "You found some Acid on a dead dude in the subway!", 0, 0, 0, 6},
	{35, "You found some PCP on a dead dude in the subway!", 3, 0, 0, 4}};
*/



}


function roundPrices()
{
   for ( var i = 0 ; i < 8 ; i++ ) 
   {
      drugPrices[i]=Math.round(drugPrices[i]);
   }
}


function displayGameOver()
{
   var msg="";
   var fc="";

   if ( dead == 0 )
   {
        // liquidate your assess. sniker .. I said asses.
        for ( var i = 0 ; i < 8 ; i++ )
        {
           cash+=drugPrices[i]*drugQtys[i];
        }

        // Make a withdrawl.
        cash+=bank;   
        //alert("withdraw bank " + cash);

        // Pay off the shark
        if ( cash > shark )
        {
           cash-=shark;
           shark=0;
        }   
        else
        {
           shark-=cash;
           cash=0;
        }
        //alert("pay off shark " + cash );
   
        // Do you owe the shark?
        if ( shark > 0 )
        {
           msg="The Loan Shark's thugs broke your legs";
           fc="You Still Owed: ";
           fc += CurrencyFormatted(shark) ;
        }
        else
        { 
           if ( cash <= 2000 )
           {
              msg="You didn't make any money!";
           }
           if ( cash > 2000 && cash < 1000000 )
           {
              msg="You didn't do half bad.";
           }
           if ( cash >= 1000000 )
           {
              msg="You retired a millionaire in the Carribbean.";
           }
     
           fc="final cash: ";
           fc += CurrencyFormatted(cash) ;

      }
   }  
   else
   {
      fc="";
      msg="Your dead...  <br>You got nothing."
   }
      


   document.getElementById('goFinalCash').innerHTML=fc;
   document.getElementById('goRank').innerHTML=msg;
   document.getElementById('face').style.display='none';
   document.getElementById('ask').style.display='none';
   document.getElementById('fuzz').style.display='none';
   document.getElementById('pockets').style.display='none';
   document.getElementById('gun').style.display='none';
   document.getElementById('borough').style.display='none';
   document.getElementById('message').style.display='none';
   document.getElementById('gameover').style.display='block';
}


function displayMessageDiv()
{
   document.getElementById('face').style.display='none';
   document.getElementById('ask').style.display='none';
   document.getElementById('fuzz').style.display='none';
   document.getElementById('pockets').style.display='none';
   document.getElementById('gun').style.display='none';
   document.getElementById('borough').style.display='none';
   //document.getElementById('messageImg').style.opacity=.8;
   document.getElementById('message').style.display='block';
}


function displayFinancialInstitutionDiv()
{
   document.getElementById('face').style.display='none';
   document.getElementById('message').style.display='none';
   document.getElementById('ask').style.display='none';
   document.getElementById('boroughBackDrop').style.opacity=.75;   
   document.getElementById('borough').style.display='none';
   document.getElementById('financialInstitution').style.display='block';

}

function displayFaceDiv()
{
   document.getElementById('ask').style.display='none';
   document.getElementById('fuzz').style.display='none';
   document.getElementById('pockets').style.display='none';
   document.getElementById('gun').style.display='none';
   document.getElementById('borough').style.display='none';
   document.getElementById('message').style.display='none';
   document.getElementById('gameover').style.display='none';
   document.getElementById('face').style.display='block';
}


function displayBoroughDiv()
{
   document.getElementById('face').style.display='none';
   document.getElementById('message').style.display='none';
   document.getElementById('ask').style.display='none';
   document.getElementById('boroughBackDrop').style.opacity=.95;  
   document.getElementById('borough').style.display='block';
   turnOnFlip();
}

function CurrencyFormatted(amount)
{
   // amount is an integer so 
   // turn it into a string.
   var s = "" + amount;

   // return string
   var ts = "";

   // Get ready to insert commas
   var c = 0;

   // Gotta do a backwords loop.
   for ( var i=s.length ; i >= 0 ; i-- )
   {
      ts = s.substring(i-1,i) + ts;
      c++;
      if ( c == 3 && s.substring(i-1,i) != "" && i>1)
      {
         ts = "," + ts;
         c=0;
      }
   }
   ts = "$" + ts;
   return ts;


/*
        var i = parseInt(amount);
        if(isNaN(i)) { i = 0.00; }
        var minus = '';
        if(i < 0) { minus = '-'; }
        i = Math.abs(i);
        i = parseInt((i + .005) * 100);
        i = i / 100;
        s = new String(i);
        if(s.indexOf('.') < 0) { s += '.00'; }
        if(s.indexOf('.') == (s.length - 2)) { s += '0'; }
        s = minus + s;
        return s;
*/
}


function displayMoney()
{
   document.getElementById('cash').innerHTML=CurrencyFormatted(cash);
   document.getElementById('bank').innerHTML=CurrencyFormatted(bank);
   document.getElementById('shark').innerHTML=CurrencyFormatted(shark);
}

function displayPockets()
{
   var totalQty=countQty();
   var pocketText="";
   pocketText+=totalQty;
   pocketText+=" / ";
   pocketText+=pockets;
   document.getElementById('havepockets').innerHTML= pocketText;

}


function displayQtys()
{
   for ( var i = 1 ; i <= 8 ; i++ )
   {
      document.getElementById("drug"+i+"Qty").innerHTML=drugQtys[i-1];
   }
}

function displayPrices()
{
   // Drug Prices
   for ( var i = 1 ; i <= 8 ; i++ )
   {
      if ( drugPrices[i-1]!=0 )
      {
         document.getElementById("drug"+i+"Price").innerHTML= CurrencyFormatted( drugPrices[i-1]);
      }
      else
      {
         document.getElementById("drug"+i+"Price").innerHTML=" ----";
      }
   }
}

function convertBorough()
{
   if ( currentBorough == "NewJersey" )
   {
      return "New Jersey";
   }
   else if ( currentBorough == "StatenIsland" )
   {
      return "Staten Island";
   }
   else
   {
      return currentBorough;
   }  
}

function turnOnFlip()
{
   document.getElementById('flip').style.display='block';
   document.getElementById('fliprollie').style.display='block';
}


function jetTo()
{
   var jet     = document.getElementById("face"); 
   var message = document.getElementById("message");
   var borough = document.getElementById("borough");

   // Where is we?
   document.getElementById("problemText").innerHTML="You are now leaving "+convertBorough();

   // First increment the day
   day++;

   // Loan Shark Interest
   shark=Math.floor ( shark*sharkInterest );

   // Bank Interest
   bank=Math.floor( bank*bankInterest );

   // Change Prices for Next Borough
   changePrices();

   fadeOut=1;
   fadeObjectOut("borough");

   setTimeout("displayJetDiv()", 100*fDelay);   
   fadeIn=.2
   setTimeout("fadeObjectIn('face')", 101*fDelay);


}
function displayJetDiv()
{
   document.getElementById('face').style.display='block';
   document.getElementById('message').style.display='none';
   document.getElementById('borough').style.display='none';
}







var fadeIn=.2
function fadeObjectIn( oid )
{
/*
   if ( fadeIn < 1 )
   {
      fadeIn+=.05;
      document.getElementById(oid).style.opacity=fadeIn;
      setTimeout("fadeObjectOut("+oid+")", 100);
   }
*/
   

/*
   for ( var i = minOpacity ; i < maxOpacity ; i+=fIncre )
   {
      setTimeout("document.getElementById('"+oid+"').style.opacity="+(i/100), i*fDelay);   
   }
   //setTimeout("document.getElementById('"+oid+"').style.opacity="+maxOpacity/100, i*fDelay);   
*/
}


var fadeOut=0;
function fadeObjectOut( oid )
{
/*
   if ( fadeOut > .2 )
   {
      fadeOut-=.05;
      document.getElementById(oid).style.opacity=fadeOut;
      setTimeout("fadeObjectOut("+oid+")", 100);
   }
*/
/*
   for ( var i = 1 ; i < 90 ; i+=fIncre )
   {
setTimeout("document.getElementById('"+oid+"').style.opacity="+((100-i)/100), i*fDelay);   
   }
*/
}



function countQty()
{
   var totalQty=0;
   for ( var i = 0 ; i < 8 ; i++ )
   {
      totalQty+=drugQtys[i];
   }
   return totalQty;
}

function buyOneDrug( drug )
{
   if ( cash > drugPrices[drug-1] && countQty() < pockets && drugPrices[drug-1] > 0 )
   {
      cash-=drugPrices[drug-1];
      drugQtys[drug-1]++;
      displayQtys();
      displayMoney();
      displayPockets();
   }
}

function buyMaxDrug( drug )
{
   if ( drugPrices[drug-1] > 0 )
   {
      var max = Math.floor( cash / drugPrices[drug-1] ) ;

      if ( max > ( pockets - countQty() ) )
      {
         max = ( pockets - countQty() ) ;
      }
 
      if ( max > 0 )
      {
         cash-=drugPrices[drug-1]*max;
         drugQtys[drug-1]+=max;
         displayQtys();
         displayMoney();   
         displayPockets();
      }
   }
}


function sellOneDrug( drug )
{
   if ( drugQtys[drug-1] > 0 && drugPrices[drug-1] > 0 ) 
   {
      drugQtys[drug-1]--;
      cash+=drugPrices[drug-1];
      displayQtys();
      displayMoney();
      displayPockets();
   }
}


function sellMaxDrug( drug )
{
   if ( drugQtys[drug-1] > 0 && drugPrices[drug-1] > 0 )
   {
      var profit = drugQtys[drug-1]*drugPrices[drug-1];
      cash+=profit;
      drugQtys[drug-1]=0;
      displayQtys();
      displayMoney();
      displayPockets();
   }
}


function initWidget()
{
   initPrices();
   initQtys();
   changePrices();
   initEvents();

   // reset vars
   cash=2000;
   bank=0;
   shark=5500; 
   currentBorough="NewJersey";
   gun=0;
   dead=0;
   day=1;
   cops=3;
   pockets=100;
   nextFi="";
   currFi="";
   currentEvent=0;
   displayFaceDiv();
}
